/*
 * Copyright (C) 1994, 1995, 1996, 1997
 *
 * Department of Computing Science,
 * The University,
 * Newcastle upon Tyne,
 * UK.
 *
 * $Id: HashedList.n,v 1.4 1997/10/08 09:09:42 nmcl Exp $ 
 */

#include <Common/Error.h>
#include <ClassLib/thread.h>

#if defined(NO_INLINES) && !defined(HASHEDLIST_CC_)

extern ostream& operator<< (ostream& strm, const HashedList& hl);

#else

#ifndef NO_INLINES
#  define INLINEF inline
#else
#  define INLINEF
#endif


INLINEF ostream& operator<< (ostream& strm, const HashedList& hl)
{
    return hl.print(strm);
}

INLINEF int HashedList::timeToKey (double time) const
{
    int toReturn = ((long) time)%listSize;

    if (toReturn < 0)
    {
	error_stream << FATAL << "HashedList::timeToKey ( " << time << " ) gives " << toReturn << endl;
	Thread::Exit(-1);
    }
    else
	return toReturn;
}

#ifdef INLINEF
#  undef INLINEF
#endif

#endif
